<template>
	<div>
		<NodesList
			v-if="!isNodesTreeNull()"
			:nodes-tree="nodesTree"
			:is-filter="false"
			@toggle-directory="toggleDirectory($event)"
			@enter-directory="currentFolder=$event" />
	</div>
</template>

<script>
import '@nextcloud/dialogs/styles/toast.scss'
import { generateUrl } from '@nextcloud/router'
import { showError } from '@nextcloud/dialogs'
import axios from '@nextcloud/axios'
import NodesList from './NodesList'

export default {
	name: 'FileExplorer',
	components: {
		NodesList,
	},
	data() {
		return {
			nodesTree: [],
		}
	},
	computed: {
		currentFolder: {
			get() {
				const res = this.$route.query.path
				return typeof res === 'undefined' ? '/' : res
			},
			set(newPath) {
				this.$router.push({
					name: 'Main',
					query: { ...this.$route.query, path: newPath },
				})
			},
		},
		sortAttribute() {
			const res = this.$route.query.sortAttribute
			return typeof res === 'undefined' ? 'name' : res
		},
		sortDescending() {
			const res = this.$route.query.sortDescending
			return typeof res === 'undefined' ? false : res
		},
	},
	watch: {
		currentFolder(newPath) {
			this.changeDirectory(newPath)
		},
	},

	/**
	 * Fetch list of files when the component is load
	 */
	async mounted() {
		try {
			this.changeDirectory(this.currentFolder)
		} catch (e) {
			console.error(e)
			showError(t('sorts', 'Could not fetch files'))
		}
	},

	methods: {

		isNodesTreeNull() {
			return !(Array.isArray(this.nodesTree) && this.nodesTree.length)
		},

		async changeDirectory(path) {
			const node = this.getNodeByPath(path)
			if (node === null) {
				const response = await this.getNodes(path)
				this.nodesTree = response.data
			} else if (node.type === 'dir') {
				if (Array.isArray(node.nodes) && node.nodes.length) {
					this.nodesTree = node.nodes
				} else {
					const response = await this.getNodes(path)
					this.nodesTree = response.data
				}
			}
		},

		/**
		 * Fetch content of given dir and add them to the nodesTree
		 *
		 * @param {string} path Path to directory to be toggle
		 */
		async toggleDirectory(path) {
			const node = this.getNodeByPath(path)
			if (node.type === 'dir') {
				if (Array.isArray(node.nodes) && node.nodes.length) {
					this.$delete(node, 'nodes')
				} else {
					const response = await this.getNodes(node.path)
					this.$set(node, 'nodes', response.data)
				}
			}
		},

		/**
		 * Fetch nodes at given path from backend
		 *
		 * @param {string} path Requested node's path
		 * @return {object | null}
		 */
		async getNodes(path) {
			if (path === '/') {
				return await axios.get(generateUrl('/apps/sorts/nodelist'), { params: { sortAttribute: this.sortAttribute, sortDescending: this.sortDescending } })
			} else {
				return await axios.get(generateUrl(`/apps/sorts/nodelist/${path}`), { params: { sortAttribute: this.sortAttribute, sortDescending: this.sortDescending } })
			}
		},

		/**
		 * Get the node at the given path if it exist in nodesTree
		 *
		 * @param {string} path Requested node's path
		 * @return {object | null}
		 */
		getNodeByPath(path) {
			const func = function(nodes) {
				for (let i = 0; i < nodes.length; i++) {
					if (nodes[i].path === path) {
						return nodes[i]
					} else if (Array.isArray(nodes[i].nodes)) {
						const res = func(nodes[i].nodes)
						if (res !== null) {
							return res
						}
					}
				}
				return null
			}
			if (!this.isNodesTreeNull()) {
				return func(this.nodesTree)
			}
			return null
		},
	},
}
</script>
